#ifndef EGSTRA_FG_DEPENDENCY_DISTANCE_H
#define EGSTRA_FG_DEPENDENCY_DISTANCE_H

/* FGDependencyDistance : a class that generates features for each
   dependency in a sentence based on the distance between the head and
   modifier.  The part numbering follows that of the first-order
   dependency parsers: dependency (h,m) is mapped to index (h + N*m),
   with h==m indicating a root dependency.  The features are based on
   POS tags, lemmas, word identities, etc. */


#include <list>
#include <string>

#include "Sentence.h"

namespace egstra {
  class fg_dependency_distance {
  public:
    static void phi(const sentence* const x, std::list<std::string> F[],
		    const int word_limit, const bool use_pos);
  };
}

#endif /* EGSTRA_FG_DEPENDENCY_DISTANCE_H */
