#ifndef EGSTRA_FG_TOKEN_CONTEXT_H
#define EGSTRA_FG_TOKEN_CONTEXT_H

/* FGTokenContext : a class that generates features for each token in
   a sentence.  The input set F is assumed to contain a set of atomic
   token features.  These features are replicated to yield a
   contextual representation of each token.  In addition, n-grams of
   parts of speech are added. */


#include <list>
#include <string>

#include "Sentence.h"

namespace egstra {
  class fg_token_context {
  public:
    static void phi(const sentence* const x, std::list<std::string> F[],
		    const int n, const int word_limit, const bool use_pos);
  };
}

#endif /* EGSTRA_FG_TOKEN_CONTEXT_H */
