/**
 * Implements the token class
 * @file Token.h
 * @author Mihai Surdeanu
 */

#ifndef EGSTRA_TOKEN_H
#define EGSTRA_TOKEN_H

#include "Constants.h"

#include <list>

namespace egstra {

class token
{
 private:
  int mWord;

  int mLemma;

  int mCoarseTag;

  int mFineTag;

  std::list<int> mMorphoFeats;

  bool mIsPunc;


 public:

  token()
    : mWord(-1), mLemma(-1), mCoarseTag(-1), mFineTag(-1)
    {}

  token(const std::string & word,
	const std::string & lemma,
	const std::string & coarseTag,
	const std::string & fineTag,
	const std::string & feats);

  void set_is_punc(bool b) { mIsPunc = b; }
  bool isPunc() const { return mIsPunc; }

  int word() const { return mWord; }
  int lemma() const { return mLemma; }
  int pos() const { return mCoarseTag; }
  int coarse_tag() const { return mCoarseTag; }
  int fine_tag() const { return mFineTag; }
  const std::list<int> & morphos() const { return mMorphoFeats; }
};

} // end namespace deeper

#endif /* EGSTRA_TOKEN_H */
