/* FVec : structure representing a sparse primal feature vector

   Author : Terry Koo
            maestro@csail.mit.edu */

#ifndef EGSTRA_FVEC_H
#define EGSTRA_FVEC_H

namespace egstra {
  struct fvec {
    const int* idx;    /* list of feature indices */
    const double* val; /* list of feature values.  if this is NULL,
			  then indicator features are assumed */
    int n;             /* number of features */
    int offset;        /* a base offset in the feature space.  each
			  feature index in idx[] is interpreted as
			  (idx[k] + offset). */
  };
}

#endif /* EGSTRA_FVEC_H */
