/************************************************************
 *
 *   Author : Terry Koo
 *            maestro@csail.mit.edu
 *
 *   Decoder : A trainer that just goes through a set of test data and
 *             assigns argmax labels.
 *
 ************************************************************/
#ifndef EGSTRA_DECODER_H
#define EGSTRA_DECODER_H

#include "Trainer.h"
#include "Register.h"

#include <vector>

namespace egstra {
  class decoder : public trainer {
  private:
    /* whether to perform minimum-risk decoding (decoding by using the
       part marginals) */
    bool _minrisk;
    /* the range of iterations to use when decoding */
    std::vector<int> _range;
    /* zero for normal decoding, or k for k-best decoding */
    int _kbest;

  public:
    decoder() : trainer() {}
    ~decoder() {}

    void usage(const char* const mesg = "");
    void process_options();

    void train(dataset& trdata, dataset& valdata, const int T);

  };

  REGISTER_TRAINER(decoder, decoder);
}


#endif /* EGSTRA_DECODER_H */
