#include "MMDEGTrainer.h"

#include "DEGTrainer.h"
#include "ObjectiveFunction.h"

using namespace std;

namespace egstra {
  mmdeg_trainer::mmdeg_trainer()
    : trainer(), _impl(new deg_trainer<obj_maxmargin>())
  {}

  mmdeg_trainer::~mmdeg_trainer() {
    delete _impl;
  }

  void mmdeg_trainer::usage(const char* const mesg) {
    assert(_impl != NULL);
    _impl->usage(mesg);
  }

  void mmdeg_trainer::process_options() {
    assert(_impl != NULL);
    _impl->process_options();
  }

  void mmdeg_trainer::train(dataset& trdata, dataset& valdata,
			    const int T) {
    assert(_impl != NULL);
    _impl->set_model(_M);
    _impl->set_fgen(_fg);
    _impl->set_dir(_dir);
    _impl->train(trdata, valdata, T);
  }
}
